//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
String  __fastcall TForm1::Hasher(String data,int hash_type)
{
  HCRYPTPROV hProv;
  HCRYPTHASH hHash;
  ALG_ID alg;

  if (hash_type==0)
      alg=CALG_MD5;  //MD5 t
  else
      alg=CALG_SHA;  //SHA t

  String r="";
  char *bSecret=data.c_str();
  DWORD cbSecret = lstrlen(bSecret);

  InitUser();

  try {
        if (!CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, 0))
		throw;

	if (!CryptCreateHash(hProv, alg, 0, 0, &hHash))
                throw;

        if (!CryptHashData(hHash, (LPBYTE)bSecret, cbSecret, 0))
                throw;



        // Get the size of the resulting salted hash.
        DWORD cbSecretHash = 0;
	DWORD cbSecretHashLen = sizeof (DWORD);

        if (!CryptGetHashParam(hHash, HP_HASHSIZE, (BYTE*)&cbSecretHash, &cbSecretHashLen, 0))
                throw;

        // Get the salted hash.
        char *pbSecretHash = new char[cbSecretHash];

        //if (NULL == *pbSecretHash) throw;
        if (pbSecretHash == NULL) throw;

        if (!CryptGetHashParam(hHash, HP_HASHVAL, pbSecretHash, &cbSecretHash, 0))
                throw;

        //cbSecretHash  hash  , MD5=16 , SHA1=20
        r=StrToHex(pbSecretHash).SubString(1,cbSecretHash*2); //MD5 ue 16  bytes

      }
  catch(...)
      {
        ShowMessage("something error");
      }



  // Destroy hash object.
  if(hHash != 0) CryptDestroyHash(hHash);

  // Release provider handle.
  if(hProv != 0) CryptReleaseContext(hProv,0);

  return (r);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::InitUser()
{
    HCRYPTPROV hProv;
    HCRYPTKEY hKey;
    CHAR szUserName[100];
    //DWORD dwUserNameLen = 100;
    unsigned long dwUserNameLen = 100;
    char tmp_buf[81];


    // Attempt to acquire a handle to the default key container.
    if (!CryptAcquireContext(&hProv, NULL, MS_DEF_PROV, PROV_RSA_FULL, 0))
       {
         // Some sort of error occured.

         // Create default key container.
         if (!CryptAcquireContext(&hProv, NULL, MS_DEF_PROV, PROV_RSA_FULL, CRYPT_NEWKEYSET))
            {
              sprintf(tmp_buf,"Error creating key container!\n");
              ShowMessage(tmp_buf);
              return;
            }

         // Get name of default key container.
         if (!CryptGetProvParam(hProv, PP_CONTAINER, szUserName, &dwUserNameLen, 0))
            {
              // Error getting key container name.
              szUserName[0] = 0;
            }

         sprintf(tmp_buf,"Create key container '%s'\n",szUserName);
         ShowMessage(tmp_buf);
       }

    // Attempt to get handle to signature key.
    if (!CryptGetUserKey(hProv, AT_SIGNATURE, &hKey))
       {
         if (GetLastError() == NTE_NO_KEY)
            {
              // Create signature key pair.
              sprintf(tmp_buf,"Create signature key pair\n");
              ShowMessage(tmp_buf);

              if (!CryptGenKey(hProv,AT_SIGNATURE,0,&hKey))
                 {
                   sprintf(tmp_buf,"Error %x during CryptGenKey (1)!\n", GetLastError());
                   ShowMessage(tmp_buf);
                   return;
                 }
              else
                 {
                   CryptDestroyKey(hKey);
                 }
            }
         else
            {
              sprintf(tmp_buf,"Error %x during CryptGetUserKey (1)!\n", GetLastError());
              ShowMessage(tmp_buf);
              return;
            }
       }

    // Attempt to get handle to exchange key.
    if (!CryptGetUserKey(hProv,AT_KEYEXCHANGE,&hKey))
       {
         if(GetLastError()==NTE_NO_KEY)
           {
             // Create key exchange key pair.
             sprintf(tmp_buf,"Create key exchange key pair\n");
             ShowMessage(tmp_buf);

             if (!CryptGenKey(hProv,AT_KEYEXCHANGE,0,&hKey))
                {
                  sprintf(tmp_buf,"Error %x during CryptGenKey (2)!\n", GetLastError());
                  ShowMessage(tmp_buf);
                  return;
                }
             else
                {
                  CryptDestroyKey(hKey);
                }

           }
         else
           {
             sprintf(tmp_buf,"Error %x during CryptGetUserKey (2)!\n", GetLastError());
             ShowMessage(tmp_buf);
             return;
           }
       }

    CryptReleaseContext(hProv,0);

}
//---------------------------------------------------------------------------
//N HASH ର HEX HKxsrܼƤ (HASH i঳iίSr)
//---------------------------------------------------------------------------
String __fastcall TForm1::StrToHex(String sour)
{
   String d="";
   for (int i=1;i<=sour.Length();i++)
       {
          d=d+IntToHex((Byte)sour[i],2);
       }

   return (d);
}
//---------------------------------------------------------------------------
// : N Edit1->Text gL MD5 t , ñNG Edit2->text
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Edit2->Text=Hasher(Edit1->Text,0);   // MD5 
}
//---------------------------------------------------------------------------
// : N Edit1->Text gL SHA t , ñNG Edit2->text
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Edit2->Text=Hasher(Edit1->Text,1);   // SHA 
}
//---------------------------------------------------------------------------
