unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    function Hasher(data:String ; hash_type:integer):String;
    procedure InitUser;
    function StrToHex(S: string): string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

//--------------------------------------
//Crypto API 2.0 ŧiϬq
//--------------------------------------
const
  ALG_CLASS_DATA_ENCRYPT = (3 shl 13);
  ALG_TYPE_BLOCK         = (3 shl  9);
  ALG_TYPE_STREAM        = (4 shl  9);
  ALG_CLASS_HASH         = (4 shl 13);
  ALG_SID_RC2            =  2;
  ALG_SID_RC4            =  1;
  ALG_TYPE_ANY           =  0;
  ALG_SID_MD5            =  3;
  ALG_SID_SHA            =  4;
  CALG_RC2 = (ALG_CLASS_DATA_ENCRYPT or ALG_TYPE_BLOCK or ALG_SID_RC2);
  CALG_RC4 = (ALG_CLASS_DATA_ENCRYPT or ALG_TYPE_STREAM or ALG_SID_RC4);
  CALG_MD5 = (ALG_CLASS_HASH or ALG_TYPE_ANY or ALG_SID_MD5);
  CALG_SHA = (ALG_CLASS_HASH or ALG_TYPE_ANY or ALG_SID_SHA);
  PROV_RSA_FULL          = 1;
  CRYPT_EXPORTABLE       = $00000001;
  CRYPT_NEWKEYSET        = $00000008;
  AT_KEYEXCHANGE         = 1;
  AT_SIGNATURE           = 2;
  SIMPLEBLOB             = $1;
  PP_CONTAINER           = 6;

  HP_ALGID          = $0001; // Hash algorithm
  HP_HASHVAL        = $0002; // Hash value
  HP_HASHSIZE       = $0004; // Hash value size

  {$IFDEF USE_BLOCK_CIPHER}
  ENCRYPT_ALGORITHM = CALG_RC2;
  ENCRYPT_BLOCK_SIZE = 8;
  {$ELSE}
  ENCRYPT_ALGORITHM = CALG_RC4;
  ENCRYPT_BLOCK_SIZE = 1;
  {$ENDIF}

  MS_DEF_PROV_A = 'Microsoft Base Cryptographic Provider v1.0';
  {$IFNDEF VER90}
  MS_DEF_PROV_W = WideString( 'Microsoft Base Cryptographic Provider v1.0');
  {$ELSE}
  MS_DEF_PROV_W = ( 'Microsoft Base Cryptographic Provider v1.0');
  {$ENDIF}

  {$IFDEF UNICODE}
  MS_DEF_PROV   = MS_DEF_PROV_W;
  {$ELSE}
  MS_DEF_PROV   = MS_DEF_PROV_A;
  {$ENDIF}

type HCRYPTPROV = ULONG;
     HCRYPTKEY  = ULONG;
     HCRYPTHASH = ULONG;
     ALG_ID     = ULONG;

     PHCRYPTPROV = ^HCRYPTPROV;
     PHCRYPTKEY  = ^HCRYPTKEY;
     PHCRYPTHASH = ^HCRYPTHASH;

     {$IFDEF UNICODE}
     LPAWSTR = PWideChar;
     {$ELSE}
     LPAWSTR = PAnsiChar;
     {$ENDIF}


{$IFDEF UNICODE}
function CryptAcquireContext(phProv       :PHCRYPTPROV;
                             pszContainer :LPAWSTR;
                             pszProvider  :LPAWSTR;
                             dwProvType   :DWORD;
                             dwFlags      :DWORD
                             ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptAcquireContextW';
{$ELSE}
function CryptAcquireContext(phProv       :PHCRYPTPROV;
                             pszContainer :LPAWSTR;
                             pszProvider  :LPAWSTR;
                             dwProvType   :DWORD;
                             dwFlags      :DWORD
                             ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptAcquireContextA';
{$ENDIF}


function CryptReleaseContext(hProv   :HCRYPTPROV;
                             dwFlags :DWORD
                             ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptReleaseContext';

function CryptGenKey(hProv   :HCRYPTPROV;
                     Algid   :ALG_ID;
                     dwFlags :DWORD;
                     phKey   :PHCRYPTKEY
                     ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptGenKey';

function CryptGetUserKey(hProv     :HCRYPTPROV;
                         dwKeySpec :DWORD;
                         phUserKey :PHCRYPTKEY
                         ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptGetUserKey';

function CryptExportKey(hKey       :HCRYPTKEY;
                        hExpKey    :HCRYPTKEY;
                        dwBlobType :DWORD;
                        dwFlags    :DWORD;
                        pbData     :PBYTE;
                        pdwDataLen :PDWORD
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptExportKey';

function CryptDestroyKey(hKey  :HCRYPTKEY
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDestroyKey';

function CryptCreateHash(hProv   :HCRYPTPROV;
                         Algid   :ALG_ID;
                         hKey    :HCRYPTKEY;
                         dwFlags :DWORD;
                         phHash  :PHCRYPTHASH
                         ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptCreateHash';

function CryptHashData(hHash       :HCRYPTHASH;
                const  pbData      :PBYTE;
                       dwDataLen   :DWORD;
                       dwFlags     :DWORD
                       ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptHashData';

function CryptDeriveKey(hProv     :HCRYPTPROV;
                        Algid     :ALG_ID;
                        hBaseData :HCRYPTHASH;
                        dwFlags   :DWORD;
                        phKey     :PHCRYPTKEY
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDeriveKey';

function CryptDestroyHash(hHash :HCRYPTHASH
                         ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDestroyHash';

function CryptEncrypt(hKey       :HCRYPTKEY;
                      hHash      :HCRYPTHASH;
                      Final      :BOOL;
                      dwFlags    :DWORD;
                      pbData     :PBYTE;
                      pdwDataLen :PDWORD;
                      dwBufLen   :DWORD
                      ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptEncrypt';

function CryptImportKey(hProv     :HCRYPTPROV;
                        pbData    :PBYTE;
                        dwDataLen :DWORD;
                        hPubKey   :HCRYPTKEY;
                        dwFlags   :DWORD;
                        phKey     :PHCRYPTKEY
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptImportKey';

function CryptDecrypt(hKey       :HCRYPTKEY;
                      hHash      :HCRYPTHASH;
                      Final      :BOOL;
                      dwFlags    :DWORD;
                      pbData     :PBYTE;
                      pdwDataLen :PDWORD
                      ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDecrypt';

function CryptGetProvParam(hProv      :HCRYPTPROV;
                           dwParam    :DWORD;
                           pbData     :PBYTE;
                           pdwDataLen :PDWORD;
                           dwFlags    :DWORD
                           ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptGetProvParam';


{$IFDEF UNICODE}
function CryptSignHash(hHash         :HCRYPTHASH;
                        dwKeySpec    :DWORD;
                        sDescription :LPAWSTR;
                        dwFlags      :DWORD;
                        pbSignature  :PBYTE;
                        pdwSigLen    :PDWORD) :BOOL;stdcall; external 'advapi32.dll' name 'CryptSignHashA';
{$ELSE}
function CryptSignHash(hHash         :HCRYPTHASH;
                        dwKeySpec    :DWORD;
                        sDescription :LPAWSTR;
                        dwFlags      :DWORD;
                        pbSignature  :PBYTE;
                        pdwSigLen    :PDWORD) :BOOL;stdcall; external 'advapi32.dll' name 'CryptSignHashW';
{$ENDIF}


function CryptGetHashParam(hHash      :HCRYPTHASH;
                           dwParam    :DWORD;
                           pbData     :PBYTE;
                           pdwDataLen :PDWORD;
                           dwFlags    :DWORD) :BOOL;stdcall; external 'advapi32.dll' name 'CryptGetHashParam';


{$R *.DFM}
//---------------------------------------------------------------------------
function TForm1.Hasher(data:String ; hash_type:integer):String;
var
  hProv : HCRYPTPROV;
  hHash : HCRYPTHASH;
  alg : ALG_ID;
  bSecret : PChar;
  cbSecret : DWORD;
  cbSecretHash : DWORD;
  cbSecretHashLen : DWORD;
  pbSecretHash : PChar;
  r:String;

begin

  if (hash_type=0) then
      alg:=CALG_MD5    //MD5 t
  else
      alg:=CALG_SHA;   //SHA t

  r:='';
  bSecret:=PChar(data);
  cbSecret:=StrLen(bSecret);

  InitUser();


        if not CryptAcquireContext(@hProv, nil, nil, PROV_RSA_FULL, 0) then
		ShowMessage('something error');

	if not CryptCreateHash(hProv, alg, 0, 0, @hHash) then
                ShowMessage('something error');

        if not CryptHashData(hHash, PBYTE(bSecret), cbSecret, 0) then
                ShowMessage('something error');



        // Get the size of the resulting salted hash.
        cbSecretHash := 0;
	cbSecretHashLen := sizeof(DWORD);

        if not CryptGetHashParam(hHash, HP_HASHSIZE, PBYTE(@cbSecretHash), @cbSecretHashLen, 0) then
                ShowMessage('something error');

        // Get the salted hash.
        GetMem(pbSecretHash, cbSecretHash);


        //if (NULL == *pbSecretHash) throw;
        if (pbSecretHash = nil) then ShowMessage('something error');

        if not CryptGetHashParam(hHash, HP_HASHVAL, pbyte(pbSecretHash), @cbSecretHash, 0) then
                ShowMessage('something error');

        //cbSecretHash  hash  , MD5=16 , SHA1=20
        r:=copy(StrToHex(pbSecretHash),1,cbSecretHash*2); //MD5 ue 16  bytes




  if(pbSecretHash<>nil) then FreeMem(pbSecretHash);

  // Destroy hash object.
  if(hHash <> 0) then CryptDestroyHash(hHash);

  // Release provider handle.
  if(hProv <> 0) then CryptReleaseContext(hProv,0);



  result:=r;

end;
//---------------------------------------------------------------------------
procedure TForm1.InitUser;
var
  hProv : HCRYPTPROV;
  hKey  : HCRYPTKEY;
  dwUserNameLen : DWORD;
  szUserName : array [0..100] of char;
  tmp_buf : array [0..80] of char;
  
begin

    hProv:=0;
    hKey:=0;
    dwUserNameLen := 100;

    // Attempt to acquire a handle to the default key container.
    if not(CryptAcquireContext(@hProv, nil, MS_DEF_PROV, PROV_RSA_FULL, 0))  then
       begin
         // Some sort of error occured.

         // Create default key container.
         if not(CryptAcquireContext(@hProv, nil, MS_DEF_PROV, PROV_RSA_FULL, CRYPT_NEWKEYSET)) then
            begin
              ShowMessage('Error creating key container!');
              Exit;
            end;

         // Get name of default key container.
         if not(CryptGetProvParam(hProv, PP_CONTAINER, (@szUserName), @dwUserNameLen, 0)) then
            begin
              // Error getting key container name.
              szUserName[0] := Char(0);
            end;

         ShowMessage('Create key container '+String(szUserName));

       end;

    // Attempt to get handle to signature key.
    if not CryptGetUserKey(hProv, AT_SIGNATURE, @hKey) then
       begin
         if (GetLastError()=DWORD(NTE_NO_KEY)) then  //[ DWORD() û]񤣥X...Delphi 5  bug ??
            begin
              // Create signature key pair.
              ShowMessage('Create signature key pair');

              if not(CryptGenKey(hProv,AT_SIGNATURE,0,@hKey)) then
                 begin
                   ShowMessage('Error during CryptGenKey (1)!');
                   Exit;
                 end
              else
                 begin
                   CryptDestroyKey(hKey);
                 end;

            end
         else
            begin
              ShowMessage('Error during CryptGetUserKey (1)!');
              Exit;
            end;
       end;

    // Attempt to get handle to exchange key.
    if not(CryptGetUserKey(hProv,AT_KEYEXCHANGE,@hKey)) then
       begin

         if(GetLastError()=DWORD(NTE_NO_KEY)) then  //[ DWORD() û]񤣥X...Delphi 5  bug ??
           begin
             // Create key exchange key pair.
             ShowMessage('Create key exchange key pair');

             if not(CryptGenKey(hProv,AT_KEYEXCHANGE,0,@hKey)) then
                begin
                  ShowMessage('Error during CryptGenKey (2)!');
                  Exit;
                end
             else
                begin
                  CryptDestroyKey(hKey);
                end;

           end
         else
           begin
             ShowMessage('Error during CryptGetUserKey (2)!');
             Exit;
           end;

       end;

    CryptReleaseContext(hProv,0);

end;
//---------------------------------------------------------------------------
//N HASH ର HEX HKxsrܼƤ (HASH i঳iίSr)
//---------------------------------------------------------------------------
function TForm1.StrToHex(S: string): string;
var
  i: integer;
begin
  Result := '';
  for i := 1 to Length( S ) do
      Result := Result + IntToHex( Ord( S[i] ), 2 );
end;
//---------------------------------------------------------------------------
// : N Edit1.Text gL MD5 t , ñNG Edit2.text
//---------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
begin
  Edit2.Text:=Hasher(Edit1.Text,0);   // MD5 
end;
//---------------------------------------------------------------------------
// : N Edit1.Text gL SHA t , ñNG Edit2.text
//---------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
begin
    Edit2.Text:=Hasher(Edit1.Text,1); // SHA 
end;

end.




